from TileType import *
from TDSUtil import *
from TDPUtilities import *
from TDSUtilities import *

def glueGenome(tdsSim):
	relationList = []

	print "Generating Genome for {} Unique Tiles".format(len(tdsSim.tiles))
	for name, tile in tdsSim.tiles.iteritems():
		relationList.append(tileRelations(tile, tdsSim))

	return relationList

def tileRelations(t, tdsSim):
	opposites = {N:S, S:N, E:W, W:E, U:D, D:U}
	relations = [[] for k in opposites.keys()]

	for name, tile in tdsSim.tiles.iteritems():
		for d, opp in opposites.items():
			if t.sides[d] == tile.sides[opp]:
				relations[d].append(t.sides[d].strength)
			else:
				relations[d].append(0)

	return relations

def condense(genomeSnippet):
	ignoreValue = 0
	result = []
	for i, v in enumerate(genomeSnippet):
		if v != ignoreValue:
			result.append((v, i))
	return result

def writeGenome(name, temp, genome, directory="Genomes"):
	if not os.path.exists(directory):
		os.makedirs(directory)
	fileName = "{}.gnm".format(name) 
	path = os.path.join(directory, fileName)
	print path
	
	with open(path, "w") as gnm:
		gnm.write("{}\n".format(name))
		gnm.write("{}\n".format(temp))
		for i, tileGenome in enumerate(genome):
			gnm.write("T{}\n".format(i))
			for side, genomeSnippet in enumerate(tileGenome):
				gnm.write("{} {}\n".format(DirAbbrevArray[side], " ".join([str(x) for x in condense(genomeSnippet)])))