majorDirs = ["N", "E", "U"]
minorDirs = ["S", "W", "D"]

DirMods = ["NU", "SU", "ND", "SD", 
	"EU", "WU", "ED", "WD",
	"UE", "DE", "UW", "DW",
	"NW", "SW", "NE", "SE",
	"UN", "DN", "DS", "US", 
	"EN", "ES", "WN", "WS"]

PSTdirs = ["NEU", "SEU", "NED", "SED", 
	"ENU", "WNU", "END", "WND",
	"UNE", "DNE", "UNW", "DNW",
 	"NUW", "SUW", "NUE", "SUE",
	"UEN", "DEN", "DES", "UES", 
	"EUN", "EUS", "WUN", "WUS" 
	]

PSTdir = {DirMods[i]:PSTdirs[i] for i in range(len(DirMods))}
DirMod = {PSTdirs[i]:DirMods[i] for i in range(len(DirMods))}

oppositeByDir = {"N":"S", "S":"N", "E":"W", "W":"E", "U":"D", "D":"U"}
oppositeByDirMod = {x:x.replace(x[0], oppositeByDir[x[0]]) for x in DirMods}

Intersections = {
	"NU":"NUxDS", "DS":"NUxDS",
	"ND":"NDxUS", "US":"NDxUS",
	"SU":"SUxDN", "DN":"SUxDN", 
	"SD":"SDxUN", "UN":"SDxUN", 

	"NE":"NExWS", "WS":"NExWS", 
	"SE":"SExWN", "WN":"SExWN",
	"NW":"NWxES", "ES":"NWxES",
	"SW":"SWxEN", "EN":"SWxEN",
	
	"WU":"WUxDE", "DE":"WUxDE",
	"EU":"EUxDW", "DW":"EUxDW",
	"WD":"WDxUE", "UE":"WDxUE",
	"ED":"EDxUW", "UW":"EDxUW"
	}

IntersectionsCurrent = {
	"NU":"NUxDN", "DN":"NUxDN",
	"ND":"NDxUN", "UN":"NDxUN",
	"SU":"SUxDS", "DS":"SUxDS", 
	"US":"SDxUS", "SD":"SDxUS", 

	"NE":"NExEN", "EN":"NExEN", 
	"SE":"SExES", "ES":"SExES",
	"NW":"NWxWN", "WN":"NWxWN",
	"SW":"SWxWS", "WS":"SWxWS",
	
	"WU":"WUxDW", "DW":"WUxDW",
	"EU":"EUxDE", "DE":"EUxDE",
	"WD":"WDxUW", "UW":"WDxUW",
	"ED":"EDxUE", "UE":"EDxUE"
	}

ExternalCommunicationOut = {
	"N":"SU",
	"S":"ND",
	"E":"WN",
	"W":"ES",
	"U":"US",
	"D":"DN",
}

ExternalCommunicationIn = {k:oppositeByDirMod[v] for k, v in ExternalCommunicationOut.items()}