from TileType import *
from TDSUtilities import *
from TDPUtilities import *

componentName = "queryCounter"

tds = TDS(componentName + ".tds")
tdp = TDP(componentName + ".tdp", tds.name)

scaffoldTiles = []
nTD = TileType(True)
nTD.name = "ScaffoldNotTileDelimiter"
for dirNum, dirAbbrev in enumerate(DirAbbrevArray):
	nTD.sides[dirNum] = Glue(1, "nTD")
#nTD.sides[D] = Glue(1, "nSD")
#nTD.sides[N] = Glue(1, "nSD")
scaffoldTiles.append(nTD)

TD = TileType(True)
TD.name = "ScaffoldTileDelimiter"
for dirNum, dirAbbrev in enumerate(DirAbbrevArray):
	TD.sides[dirNum] = Glue(1, "TD")
TD.color = "Magenta"
scaffoldTiles.append(TD)

SD = TileType(True)
SD.name = "ScaffoldSideDelimiter"
SD.sides[D] = Glue(1, "nTD")
#SD.sides[D] = Glue(1, "SD")
#SD.sides[N] = Glue(1, "SD")
SD.color = "Green"
scaffoldTiles.append(SD)

tds.AddTiles(scaffoldTiles)

sidesGap = 5
numSides = 6
numTiles = 10

scaffoldCounter = 0
tilePeriod = numSides * sidesGap
for tileNum in range(numTiles):
	tdp.TileAndLocationList.append(TileAndLocation(TD.name, [scaffoldCounter, 0, 1]))
	scaffoldCounter += 1
	for sideNum in range(numSides):
		tdp.TileAndLocationList.append(TileAndLocation(SD.name, [scaffoldCounter, 0, 1]))
		scaffoldCounter += 1
		for i in range(sidesGap):
			tdp.TileAndLocationList.append(TileAndLocation(nTD.name, [scaffoldCounter, 0, 1]))
			scaffoldCounter += 1


def getTileByName(name, tileSet):
	for tile in tileSet:
		if tile.name == name:
			return tile
	print name + " not found"
	return TileType(True)

def getOppositeDirection(dir):
    directionPairs = [["N", "S"], ["E", "W"], ["U", "D"]]
    for pair in directionPairs:
        if dir in pair:
            index = [i for i,x in enumerate(pair) if x == dir]
            oppositeDirection = pair[(index[0]+1)%2] 
    return oppositeDirection

def getIndex(item, list):
    index = [i for i,x in enumerate(list) if x == item]
    return index[0]

primaryDirection = "N"
primaryDirectionReverse = getOppositeDirection(primaryDirection)
secondaryDirection = "E"
secondaryDirectionReverse = getOppositeDirection(secondaryDirection)
tertiaryDirection = "U"
tertiaryDirectionReverse = getOppositeDirection(tertiaryDirection)

primaryDirection = getIndex(primaryDirection, DirAbbrevArray)
primaryDirectionReverse = getIndex(primaryDirectionReverse, DirAbbrevArray)
secondaryDirection = getIndex(secondaryDirection, DirAbbrevArray)
secondaryDirectionReverse = getIndex(secondaryDirectionReverse, DirAbbrevArray)
tertiaryDirection = getIndex(tertiaryDirection, DirAbbrevArray)
tertiaryDirectionReverse = getIndex(tertiaryDirectionReverse, DirAbbrevArray)

counterTiles = []

t = TileType(True)
t.name = "QueryCounter-Start-Genome"
t.sides[tertiaryDirection] = Glue(2, "QueryCounter-Advance")
t.sides[secondaryDirection] = Glue(2, "QueryCounter-Advance")
t.color = "Cyan"
counterTiles.append(t)

t = TileType(True)
t.name = "QueryCounter-Advance"
t.sides[secondaryDirectionReverse] = Glue(2, "QueryCounter-Advance")
t.sides[secondaryDirection] = Glue(1, "0" + "l" + "m")
t.color = "Cyan"
counterTiles.append(t)

tdp.TileAndLocationList.append(TileAndLocation(t.name, [0, 0, 0]))

bitStates = ["0", "1"]
data = ""
for bit in bitStates:
	t = TileType(True)
	data = bit + "lm"
	t.name = "-".join(["LSB+MSB", data, "TD"])
	t.sides[secondaryDirectionReverse] = Glue(1, data)
	t.sides[tertiaryDirectionReverse] = Glue(1, "TD")
	if bit == "1":
		t.sides[secondaryDirection] = Glue(1, "0" + "l")
		t.sides[primaryDirection] = Glue(2, "newMSB")
	else:
		t.sides[secondaryDirection] = Glue(1, "1" + "lm")
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	data = bit + "lm"
	t.name = "-".join(["LSB+MSB", data, "nTD"])
	t.sides[secondaryDirectionReverse] = Glue(1, data)
	t.sides[tertiaryDirectionReverse] = Glue(1, "nEQprop")
	t.sides[tertiaryDirection] = Glue(1, "nTD")
	t.sides[secondaryDirection] = Glue(1, data)
	if bit == "1":
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	data = bit + "l"
	t.name = "-".join(["LSB", data, "nTD"])
	t.sides[secondaryDirectionReverse] = Glue(1, data)
	t.sides[tertiaryDirectionReverse] = Glue(1, "nTD")
	t.sides[tertiaryDirection] = Glue(1, "nEQprop")
	t.sides[primaryDirection] = Glue(1, "prop")
	t.sides[secondaryDirection] = Glue(1, data)
	if bit == "1":
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	data = bit + "l"
	t.name = "-".join(["LSB", data, "TD"])
	t.sides[secondaryDirectionReverse] = Glue(1, bit + "l")
	t.sides[tertiaryDirectionReverse] = Glue(1, "TD")
	if bit == "1":
		t.sides[primaryDirection] = Glue(1, "borrow")
		t.sides[secondaryDirection] = Glue(1, "0" + "l")
		t.sides[tertiaryDirection] = Glue(1, "0" + "l")
	else:
		t.sides[primaryDirection] = Glue(1, "noBorrow")
		t.sides[secondaryDirection] = Glue(1, "1" + "l")
		t.sides[tertiaryDirection] = Glue(1, "1" + "l")
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	t.name = "-".join(["REG", bit, "noBorrow"])
	t.sides[secondaryDirection] = Glue(1, bit)
	t.sides[secondaryDirectionReverse] = Glue(1, bit)
	t.sides[primaryDirection] = Glue(1, "noBorrow")
	t.sides[primaryDirectionReverse] = Glue(1, "noBorrow")
	t.sides[tertiaryDirection] = Glue(1, bit)
	if bit == "1":
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	t.name = "-".join(["REG", bit, "prop"])
	t.sides[secondaryDirection] = Glue(1, bit)
	t.sides[secondaryDirectionReverse] = Glue(1, bit)
	t.sides[primaryDirection] = Glue(1, "prop")
	t.sides[primaryDirectionReverse] = Glue(1, "prop")
	if bit == "1":
		t.color = "Blue"
	counterTiles.append(t)

	t = TileType(True)
	t.name = "-".join(["REG", bit, "borrow"])
	t.sides[secondaryDirectionReverse] = Glue(1, bit)
	t.sides[primaryDirectionReverse] = Glue(1, "borrow")
	if bit == "1":
		t.sides[secondaryDirection] = Glue(1, "0")
		t.sides[tertiaryDirection] = Glue(1, "0")
		t.sides[primaryDirection] = Glue(1, "borrow")
	else:
		t.sides[secondaryDirection] = Glue(1, "1")
		t.sides[tertiaryDirection] = Glue(1, "1")
		t.sides[primaryDirection] = Glue(1, "noBorrow")
		t.color = "Blue"
	counterTiles.append(t)

	

t = TileType(True)
t.name = "-".join(["MSB", "1", "newMSB"])
data = "1m"
t.sides[secondaryDirection] = Glue(1, data)
t.sides[primaryDirectionReverse] = Glue(2, "newMSB")
t.sides[tertiaryDirection] = Glue(1, data)
t.color = "Blue"
counterTiles.append(t)

t = TileType(True)
t.name = "-".join(["MSB", "1", "prop"])
t.sides[secondaryDirectionReverse] = Glue(1, data)
t.sides[secondaryDirection] = Glue(1, data)
t.sides[primaryDirectionReverse] = Glue(1, "prop")
t.color = "Blue"
counterTiles.append(t)

t = TileType(True)
t.name = "-".join(["MSB", "1", "noBorrow"])
t.sides[secondaryDirectionReverse] = Glue(1, data)
t.sides[secondaryDirection] = Glue(1, data)
t.sides[primaryDirectionReverse] = Glue(1, "noBorrow")
t.sides[tertiaryDirection] = Glue(1, data)
t.color = "Blue"
counterTiles.append(t)

t = TileType(True)
t.name = "-".join(["MSB", "1", "borrow"])
t.sides[secondaryDirectionReverse] = Glue(1, data)
t.sides[secondaryDirection] = Glue(1, "0")
t.sides[primaryDirectionReverse] = Glue(1, "borrow")
t.sides[primaryDirection] = Glue(2, "newMSB")
t.sides[tertiaryDirection] = Glue(1, "0")
counterTiles.append(t)

tds.AddTiles(counterTiles)



checkEqualTiles = []
possibleData = []
possibleModifiers = ["lm", "l", "", "m"]
for bit in bitStates:
	for mod in possibleModifiers:
		if mod == "m":
			if bit == "0":
				continue
		possibleData.append(bit + mod)

for data in possibleData:
	t = TileType(True)
	t.name = "-".join(["checkEqual", "Seed", data])
	t.sides[secondaryDirection] = Glue(1, data)
	if "1" in data:
		t.color = "Blue"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "-".join(["checkEqual", "nEQprop", data])
	t.sides[secondaryDirectionReverse] = Glue(1, data)
	t.sides[secondaryDirection] = Glue(1, data)
	t.sides[primaryDirection] = Glue(1, "nEQprop")
	if "l" in data:
		t.sides[tertiaryDirectionReverse] = Glue(1, "nEQprop")
		t.sides[primaryDirection] = Glue(1, "nEQprop")
	elif "m" in data and "l" not in data:
		t.sides[primaryDirectionReverse] = Glue(1, "nEQprop")
		t.sides[primaryDirection] = Glue(1, "nEQprop")
	else:
		t.sides[primaryDirectionReverse] = Glue(1, "nEQprop")
		t.sides[primaryDirection] = Glue(1, "nEQprop")
	if "1" in data:
		t.color = "Blue"
	checkEqualTiles.append(t)

	for data2 in possibleData:
		t = TileType(True)
		t.name = "-".join(["checkEqual", "Compare", data, data2])
		t.sides[secondaryDirection] = Glue(1, data)
		t.sides[secondaryDirectionReverse] = Glue(1, data)
		t.sides[tertiaryDirectionReverse] = Glue(1, data2)
		if data == data2:
			t.color = "Green"
			if "lm" in data:
				t.sides[tertiaryDirection] = Glue(2, "Equal-STOP")
				t.sides[primaryDirection] = Glue(1, "nEQprop")
			elif "m" in data and "l" not in data:
				t.sides[tertiaryDirection] = Glue(1, "Equal-STOP")
				t.sides[primaryDirection] = Glue(1, "nEQprop")
			elif "l" in data and "m" not in data:
				t.sides[tertiaryDirection] = Glue(2, "Equal")
			else:
				t.sides[tertiaryDirection] = Glue(1, "Equal")
		else:
			t.color = "Red"
			t.sides[tertiaryDirection] = Glue(1, "notEqual")
			if "lm" in data2:
				t.sides[primaryDirection] = Glue(1, "nEQprop")

			if "m" in data:
				t.sides[primaryDirection] = Glue(1, "nEQprop")

			if "l" not in data and "m" not in data:
				if "m" in data2:
					t.sides[primaryDirection] = Glue(1, "nEQprop")
				#if "lm" in data:
					#if "0" in data2 and "1" in data:
					#	t.sides[primaryDirection] = Glue(0, "")
			#elif "l" in data2:

		"""if data2 == "0lm":
			t.sides[primaryDirection] = Glue(1, "nEQprop")

		if "m" in data2 and "m" not in data:
			if data2 != "1lm":
				t.sides[primaryDirection] = Glue(1, "nEQprop")
		if data != data2:
			t.sides[tertiaryDirection] = Glue(1, "notEqual")
			if "l" in data:
				t.sides[tertiaryDirection] = Glue(2, "notEqual")
		else:
			if "l" in data:
				t.sides[tertiaryDirection] = Glue(2, "Equal")
			elif "m" in data:
				t.sides[tertiaryDirection] = Glue(1, "Equal-STOP")
				t.sides[primaryDirection] = Glue(1, "nEQprop")
			else:
				t.sides[tertiaryDirection] = Glue(1, "Equal")"""
		checkEqualTiles.append(t)

possibleStates = ["notEqual", "Equal", "Equal-STOP"]

for stateMem in possibleStates:
	t = TileType(True)
	t.name = "-".join(["checkEqual", "LSB", stateMem])
	t.sides[tertiaryDirectionReverse] = Glue(2, stateMem)
	t.sides[primaryDirection] = Glue(1, stateMem)
	if stateMem == possibleStates[2]:
		t.sides[primaryDirection] = Glue(1, "Success")
	if stateMem == possibleStates[0]:
		t.color = "Red"
	else:
		t.color = "Green"
	checkEqualTiles.append(t)

	for stateInput in possibleStates:
		if stateMem == possibleStates[2]:
			continue
		t = TileType(True)
		t.name = "-".join(["checkEqual", stateMem, stateInput])
		t.sides[primaryDirectionReverse] = Glue(1, stateMem)
		t.sides[tertiaryDirectionReverse] = Glue(1, stateInput)
		if stateMem == possibleStates[0] or stateInput == possibleStates[0]:
 			t.sides[primaryDirection] = Glue(0, possibleStates[0])
 			t.color = "Red"
 		else:
 			t.color = "Green"
 			if stateInput == possibleStates[1]:
 				t.sides[primaryDirection] = Glue(1, possibleStates[1])
 			else:
 				t.sides[primaryDirection] = Glue(1, "Success")
 		checkEqualTiles.append(t)

t = TileType(True)
t.name = "-".join(["checkEqual", "LSB", "EQ"])
t.sides[tertiaryDirectionReverse] = Glue(2, "Equal")
t.sides[primaryDirection] = Glue(1, "Equal")
t.color = "Green"
checkEqualTiles.append(t)

t = TileType(True)
t.name = "-".join(["checkEqual", "LSB", "nEQ"])
t.sides[tertiaryDirectionReverse] = Glue(2, "notEqual")
t.sides[primaryDirection] = Glue(1, "notEqual")
t.color = "Red"
checkEqualTiles.append(t)

for dirAbbrev in DirAbbrevArray:
	t = TileType(True)
	t.name = dirAbbrev
	for dirNum, d in enumerate(DirAbbrevArray):
		t.sides[dirNum] = Glue(1, dirAbbrev)
	t.color = "Cyan"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = dirAbbrev + "nEQprop"
	t.sides[secondaryDirection] = Glue(1, dirAbbrev)
	t.sides[secondaryDirectionReverse] = Glue(1, dirAbbrev)
	t.sides[primaryDirectionReverse] = Glue(1, "nEQprop")
	t.sides[primaryDirection] = Glue(1, dirAbbrev)
	t.sides[tertiaryDirection] = Glue(1, dirAbbrev)
	t.sides[tertiaryDirectionReverse] = Glue(1, dirAbbrev)
	t.color = "Cyan"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev
	t.sides[tertiaryDirectionReverse] = Glue(1, dirAbbrev)
	t.sides[primaryDirectionReverse] = Glue(1, "Success")
	t.sides[primaryDirection] = Glue(2, "Success" + dirAbbrev + "Turn1")
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "Turn1"
	t.sides[primaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "Turn1")
	t.sides[tertiaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "Advance1")
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "Advance1"
	t.sides[tertiaryDirection] = Glue(2, "Success" + dirAbbrev + "Advance1")
	t.sides[tertiaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "Advance2")
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "Advance2"
	t.sides[tertiaryDirection] = Glue(2, "Success" + dirAbbrev + "Advance2")
	t.sides[tertiaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "Turn2")
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "Turn2"
	t.sides[tertiaryDirection] = Glue(2, "Success" + dirAbbrev + "Turn2")
	t.sides[primaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "Collision")
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "Collision"
	t.sides[primaryDirectionReverse] = Glue(2,"Success" + dirAbbrev + "Collision")
	t.sides[primaryDirection] = Glue(2,"Success" + dirAbbrev + "Collision")
	t.sides[secondaryDirection] = Glue(1, "-".join(["_", dirAbbrev]))
	t.color = "Green"
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "AfterCollision"
	t.sides[secondaryDirectionReverse] = Glue(1, "-".join(["_", dirAbbrev]))
	t.sides[primaryDirectionReverse] = Glue(1, "SD")
	if dirAbbrev != "N":
		t.sides[tertiaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "AfterCollision+1")
	else:
		t.sides[secondaryDirection] = Glue(1, "ActivateProp")
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "AfterCollision+1"
	t.sides[tertiaryDirection] = Glue(2, "Success" + dirAbbrev + "AfterCollision+1")
	t.sides[primaryDirectionReverse] = Glue(2, "Success" + dirAbbrev + "AfterCollision+2")
	t.sides[secondaryDirection] = Glue(1, "N-" + dirAbbrev)
	checkEqualTiles.append(t)

	t = TileType(True)
	t.name = "Success" + dirAbbrev + "AfterCollision+2"
	t.sides[primaryDirection] = Glue(2, "Success" + dirAbbrev + "AfterCollision+2")
	t.sides[secondaryDirection] = Glue(1, "N-" + dirAbbrev)
	checkEqualTiles.append(t)

	t = TileType(True)
	for i, dir in enumerate(DirAbbrevArray):
		t = TileType(True)
		t.name = "-".join(["nSD", dir, dirAbbrev])
		t.sides[tertiaryDirection] = Glue(1, "nSD")
		t.sides[secondaryDirection] = Glue(1, "-".join([dir, dirAbbrev]))
		t.sides[secondaryDirectionReverse] = Glue(1, "-".join([dir, dirAbbrev]))
		checkEqualTiles.append(t)

		t = TileType(True)
		t.name = "-".join(["SD", dir, dirAbbrev])
		t.sides[tertiaryDirection] = Glue(1, "SD")
		if dirAbbrev == "N":
			break
		t.sides[secondaryDirectionReverse] = Glue(1, "-".join([dir, dirAbbrev]))
		if i != 5:
			if DirAbbrevArray[i+1] == dirAbbrev:
				t.sides[primaryDirection] = Glue(2, "Final-2")
			else:
				t.sides[secondaryDirection] = Glue(1, "-".join([DirAbbrevArray[i+1], dirAbbrev]))
		checkEqualTiles.append(t)

		if DirAbbrevArray[i] == dirAbbrev:
			break

t = TileType(True)
t.name = "Final-2"
t.sides[primaryDirectionReverse] = Glue(2, "Final-2")
t.sides[tertiaryDirection] = Glue(2, "Final-1")
checkEqualTiles.append(t)

t = TileType(True)
t.name = "Final-1"
t.sides[tertiaryDirectionReverse] = Glue(2, "Final-1")
t.sides[secondaryDirection] = Glue(1, "ActivateProp")
checkEqualTiles.append(t)


"""t = TileType(True)
t.name = "Activate-Advance"
t.sides[primaryDirectionReverse] = Glue(2, "Activate-Advance")
t.sides[tertiaryDirectionReverse] = Glue(2, "Activate-Turn")
checkEqualTiles.append(t)

t = TileType(True)
t.name = "Activate-Turn"
t.sides[tertiaryDirection] = Glue(2, "Activate-Turn")
t.sides[primaryDirection] = Glue(2, "Activate")
checkEqualTiles.append(t)"""



tds.AddTiles(checkEqualTiles)

def targetNumToBinary(targetNum):
	targetBinary = bin(targetNum).replace("0b","")[::-1]
	l = []
	for c in targetBinary:
		l.append(c)
	if len(l) == 1:
		l[0] += "lm"
	elif len(l) > 0:
		l[0] += "l"
		l[-1] += "m"
	return l

targetDir = "D"
targetNum = 3
targetData = None
targetData = targetNumToBinary(targetNum)
print targetData

for i, data in enumerate(targetData):
	tdp.TileAndLocationList.append(TileAndLocation("-".join(["checkEqual", "Seed", data]), [-1, -1, (-1 * i)]))
tdp.TileAndLocationList.append(TileAndLocation(targetDir, [-1, -1, (-1 * len(targetData))]))


queryTDS = TDS("QueryCounter.tds", counterTiles)
#queryTDS.Write()

equalTDS = TDS("CheckEqual.tds", checkEqualTiles)
#equalTDS.Write()

tdp.Write("TDS")
tds.Write("TDS")
