def log2(n):
    return n.bit_length()

def Nav(m):
    return 11 + 3 * log2(m)

def DP_glue(m, T, t):
    return max(Nav(m), log2(t))

def DP_adder(m, T, t):
    return Nav(m) + T * (2 + 6 * log2(t) + log2(11 + 3 * log2(m * t)))

def DP_bracket(m, T, t):
    return Nav(m) + T * (24 + 3 * log2(11 + 3 * log2(m * t)))

def DP_input(m, T, t):
    return max(Nav(m) + 25 + 5 * log2(m), log2(T))

def G_inst(m, T, t):
    return 4 * DP_input(m, T, t) + 40

def G_glue(m, T, t):
    return 6 * T**2 * (DP_glue(m, T, t) + 4)

def G_init(m, T, t):
    return 19 * DP_adder(m, T, t) + log2(T) * (DP_bracket(m, T, t) + 1) + 7 * (DP_input(m, T, t) + 1)

def needed(m, T, t):
    return G_inst(m, T, t) + G_glue(m, T, t) + G_init(m, T, t) + 2 * (DP_input(m, T, t) + 10)

def calcScaleFactor(T, t):
    m = 1
    n = needed(m, T, t)
    while m < n:
        m *= 2
        n = needed(m, T, t)
    a = m / 2
    b = m

    while b - a > 1:
        c = (a + b) / 2
        n = needed(c, T, t)
        if c < n:
            a = c
        else:
            b = c
    return b