
import sys

# za, zb are the input heights of the bracket
# k is the order of the bracket
def single_bracket(file, za, zb, k, x = 0, y = 0, z = 0):
    t = za;
    za = max(za, zb)
    zb = min(zb, t)

    mid = int((za + zb) / 2);

    file.write("Turn_Barrier_A " + str(x) + " " + str(y + 5 * k + 6) + " " + str(za) + "\n")
    file.write("Turn_Barrier_B " + str(x) + " " + str(y + 5 * k + 6) + " " + str(za - 1) + "\n")
    file.write("Turn_Barrier_A " + str(x) + " " + str(y + 5 * k + 6) + " " + str(zb) + "\n")
    file.write("Turn_Barrier_B " + str(x) + " " + str(y + 5 * k + 6) + " " + str(zb + 1) + "\n")

    file.write("Merge_Barrier_A " + str(x) + " " + str(y + 5 * k + 5) + " " + str(mid + 2) + "\n")
    file.write("Merge_Barrier_Up_B " + str(x) + " " + str(y + 5 * k + 4) + " " + str(mid + 2) + "\n")
    file.write("Merge_Barrier_A " + str(x) + " " + str(y + 5 * k + 5) + " " + str(mid - 2) + "\n")
    file.write("Merge_Barrier_Down_B " + str(x) + " " + str(y + 5 * k + 4) + " " + str(mid - 2) + "\n")

    return mid


outfile = open(sys.argv[1], 'w')

outfile.write("bracket.tds\nTemperature=2\n")

competitors = int(sys.argv[2])
bits = len(bin(competitors - 1)[2:])

arr = []
for i in range(competitors):
    zpos = 12 * i
    binary_i = bin(i)[2:]
    while len(binary_i) < bits:
        binary_i = '0' + binary_i

    outfile.write("Carrier_Start 0 0 " + str(zpos) + "\n")

    pos = -1
    for c in binary_i:
        outfile.write("Digit_" + c + " " + str(pos) + " 0 " + str(zpos) + "\n")
        pos -= 1

    arr.append((zpos, 0))



while len(arr) > 1:
    a = arr[0]
    b = arr[1]

    if a[1] != b[1]:
        arr = arr[1:] + [(a[0], a[1]+1)]
    else:
        tmp = single_bracket(outfile, a[0], b[0], a[1])
        arr = arr[2:] + [(tmp, a[1]+1)]

outfile.close();